## speed-dreams 2.2.2

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6.0 FATAL_ERROR)

# Speed Dreams project
PROJECT(speed-dreams-2)

INCLUDE(cmake/macros.cmake)
INCLUDE(cmake/checks.cmake)

CHECK_HEADERS_H()
CHECK_FUNCTIONS()
CHECK_LIBRARIES()

# Determine version
SET(NEXT_LESSER_VERSION 2) # The next lesser version
SET(NEXT_MAJOR_MINOR_VERSION "2.2") # Next major.minor version

# Uncomment if you don't want automatic SVN version detection
# (poor performances under Windows, don't work with git-svn, ...)
# SET(OPTION_AUTOVERSION Off)

IF(NOT OPTION_AUTOVERSION)
	
	SET(VERSION "${NEXT_MAJOR_MINOR_VERSION}-dev")
	SET(VERSION_LONG "${VERSION}")
	
	MESSAGE(STATUS "Version '${VERSION_LONG}' (not auto-detected from SVN source tree)")

ELSE(NOT OPTION_AUTOVERSION)

	# Use SVN HeadURL property on this CMakeLists.txt file in order to automatically get the current version
	SET(HEAD_URL "$HeadURL: https://svn.code.sf.net/p/speed-dreams/code/tags/2.2.2/CMakeLists.txt $")

	# Define regular expressions
	SET(REGEX_TAG        "^\\$HeadURL:.*speed-dreams/code/tags/([^/\\$ ]*).*\\$$")
	SET(REGEX_BUG_BRANCH "^\\$HeadURL:.*speed-dreams/code/branches/([0-9]+\\.[0-9]+)(\\.[xX])?/.*\\$$")
	SET(REGEX_TRUNK      "^\\$HeadURL:.*speed-dreams/code/trunk/.*\\$$")
	SET(REGEX_BRANCH     "^\\$HeadURL:.*speed-dreams/code/branches/([^/\\$ ]*).*\\$$")

	# Check regular expressions
	STRING(REGEX MATCH "${REGEX_TAG}"        VERSION_IS_TAG "${HEAD_URL}")
	STRING(REGEX MATCH "${REGEX_BUG_BRANCH}" VERSION_IS_BUG_BRANCH "${HEAD_URL}")
	STRING(REGEX MATCH "${REGEX_TRUNK}"      VERSION_IS_TRUNK "${HEAD_URL}")
	STRING(REGEX MATCH "${REGEX_BRANCH}"     VERSION_IS_BRANCH "${HEAD_URL}")

	# See if we need to look at the current SVN revision
	SET(NEED_SVN_REV TRUE)
	IF(VERSION_IS_TAG)
		STRING(REGEX REPLACE "${REGEX_TAG}" "\\1" VERSION "${HEAD_URL}")
	ELSEIF(VERSION_IS_BUG_BRANCH)
		STRING(REGEX REPLACE "${REGEX_BUG_BRANCH}" "\\1" TMP_VERSION "${HEAD_URL}")
		SET(VERSION "${TMP_VERSION}.${NEXT_LESSER_VERSION}-dev")
	ELSEIF(VERSION_IS_TRUNK)
		SET(VERSION "${NEXT_MAJOR_MINOR_VERSION}-trunk")
	ELSEIF(VERSION_IS_BRANCH)
		STRING(REGEX REPLACE "${REGEX_BRANCH}" "\\1" VERSION "${HEAD_URL}")
	ELSE(VERSION_IS_TAG)
		MESSAGE("Warning: Could not determine version name from HeadURL ${HEAD_URL}")
		SET(VERSION "${NEXT_MAJOR_MINOR_VERSION}-dev")
		SET(NEED_SVN_REV FALSE)
	ENDIF(VERSION_IS_TAG)
	
	# Try to get current SVN revision
	IF(NEED_SVN_REV)
		SET(SVN_FIND_REV_FAILED FALSE)
		FIND_PROGRAM(SVNVERSION_EXEC svnversion PATHS /usr/local/bin /usr/bin)
		MARK_AS_ADVANCED(SVNVERSION_EXEC)
		IF(NOT SVNVERSION_EXEC)
			SET(SVN_FIND_REV_FAILED TRUE)
		ENDIF(NOT SVNVERSION_EXEC)
		IF(NOT SVN_FIND_REV_FAILED)
			MESSAGE(STATUS "Looking for current subversion revision (may be long) ...")
			EXECUTE_PROCESS(COMMAND ${SVNVERSION_EXEC} ${CMAKE_CURRENT_SOURCE_DIR} --no-newline
							RESULT_VARIABLE SVNVERSION_RESULT
							OUTPUT_VARIABLE SVN_REV_LONG)
			IF(NOT ${SVNVERSION_RESULT} EQUAL 0)
				SET(SVN_FIND_REV_FAILED TRUE)
			ENDIF(NOT ${SVNVERSION_RESULT} EQUAL 0)
		ENDIF(NOT SVN_FIND_REV_FAILED)
		IF(NOT SVN_FIND_REV_FAILED)
			IF("${SVN_REV_LONG}" MATCHES ":")
				STRING(REGEX REPLACE "^[^:]*:(.*)$" "\\1" SVN_REV "${SVN_REV_LONG}")
			ELSE("${SVN_REV_LONG}" MATCHES ":")
				SET(SVN_REV "${SVN_REV_LONG}")
			ENDIF("${SVN_REV_LONG}" MATCHES ":")
			IF(NOT SVN_REV)
				SET(SVN_FIND_REV_FAILED TRUE)
			ENDIF(NOT SVN_REV)
		ENDIF(NOT SVN_FIND_REV_FAILED)
		SET(VERSION_LONG "${VERSION}")
		IF(NOT SVN_FIND_REV_FAILED)
			STRING(TOLOWER ${SVN_REV} SVN_REV)
			SET(VERSION_LONG "${VERSION_LONG}-r${SVN_REV}")
		ENDIF(NOT SVN_FIND_REV_FAILED)
	ELSE(NEED_SVN_REV)
		SET(VERSION_LONG "${VERSION}")
	ENDIF(NEED_SVN_REV)

	MESSAGE(STATUS "Version '${VERSION_LONG}'")

ENDIF(NOT OPTION_AUTOVERSION)

# Generate config.h
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/cmake/config.h.in.cmake
               ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# Generate DOxygen configuration file
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/cmake/doxygenconfig.in.cmake
               ${CMAKE_CURRENT_BINARY_DIR}/doxygen_config @ONLY)


# Fictive = no-output target, for having source files available in IDEs.
SET(_SOURCES CHANGES.txt COPYING.txt INSTALL.txt README.txt)
ADD_CUSTOM_TARGET(rootdoc SOURCES ${_SOURCES} data/data/credits.xml)

# Install top tree data files
SD_INSTALL_FILES(DATA "/"  FILES ${_SOURCES})

# Initialize user settings file management (before any of them is collected).
SD_SETUP_SETTINGS_VERSION()

# Sub-dirs to build ...					   
ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(data)
ADD_SUBDIRECTORY(cmake)

# After the user settings files have been collected,
# Update (and then install) version.xml from their respective version.
SD_UPDATE_SETTINGS_VERSION()

# Usefull for using an installation of SD as a robot development framework without building it.
INSTALL_SD_CMAKE()

# Generate a 'make clobber'-like clobber.sh/.bat script in case of an in-source build.
IF("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
	SD_GENERATE_CLOBBER_SCRIPT()
ENDIF("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")

# Add an unistall target.
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/cmake/uninstall.cmake" 
               "${CMAKE_CURRENT_BINARY_DIR}/uninstall.cmake" IMMEDIATE @ONLY)
IF(MSVC)
	SET(_UNINST_TGT_NAME "UNINSTALL")
ELSE(MSVC)
	SET(_UNINST_TGT_NAME "uninstall")
ENDIF(MSVC)
ADD_CUSTOM_TARGET(${_UNINST_TGT_NAME} "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/uninstall.cmake" )

# Configure CPack.
INCLUDE(cmake/packagemaker.cmake)

=== data/data/CMakeLists.txt ===
INCLUDE(../../cmake/macros.cmake)

SD_INSTALL_FILES(DATA data FILES credits.xml)

ADD_SUBDIRECTORY(fonts)
ADD_SUBDIRECTORY(icons)
ADD_SUBDIRECTORY(img)
ADD_SUBDIRECTORY(menu)
ADD_SUBDIRECTORY(objects)
ADD_SUBDIRECTORY(sound)
ADD_SUBDIRECTORY(sky)
ADD_SUBDIRECTORY(textures)
ADD_SUBDIRECTORY(tracks)
  ADD_SUBDIRECTORY(music)
IF(OPTION_OSGGRAPH)
  ADD_SUBDIRECTORY(shaders)
ENDIF(OPTION_OSGGRAPH)

=== data/drivers/CMakeLists.txt ===
INCLUDE(../../cmake/macros.cmake)

# Official robots.
SD_ADD_SUBDIRECTORY(human)
SD_ADD_SUBDIRECTORY(networkhuman)

SD_ADD_SUBDIRECTORY(simplix)
SD_ADD_SUBDIRECTORY(simplix_36GP)
SD_ADD_SUBDIRECTORY(simplix_ls1)
SD_ADD_SUBDIRECTORY(simplix_ls2)
SD_ADD_SUBDIRECTORY(simplix_mpa1)
SD_ADD_SUBDIRECTORY(simplix_mpa11)
SD_ADD_SUBDIRECTORY(simplix_mpa12)
SD_ADD_SUBDIRECTORY(simplix_mp5)
SD_ADD_SUBDIRECTORY(simplix_sc)
SD_ADD_SUBDIRECTORY(simplix_srw)
SD_ADD_SUBDIRECTORY(simplix_trb1)

SD_ADD_SUBDIRECTORY(usr_36GP)
SD_ADD_SUBDIRECTORY(usr_ls1)
SD_ADD_SUBDIRECTORY(usr_ls2)
SD_ADD_SUBDIRECTORY(usr_rs)
SD_ADD_SUBDIRECTORY(usr_sc)
SD_ADD_SUBDIRECTORY(usr_trb1)

SD_ADD_SUBDIRECTORY(dandroid_36GP)
SD_ADD_SUBDIRECTORY(dandroid_67GP)
SD_ADD_SUBDIRECTORY(dandroid_ls1)
SD_ADD_SUBDIRECTORY(dandroid_ls2)
SD_ADD_SUBDIRECTORY(dandroid_mpa1)
SD_ADD_SUBDIRECTORY(dandroid_mpa11)
SD_ADD_SUBDIRECTORY(dandroid_mpa12)
SD_ADD_SUBDIRECTORY(dandroid_rs)
SD_ADD_SUBDIRECTORY(dandroid_sc)
SD_ADD_SUBDIRECTORY(dandroid_srw)
SD_ADD_SUBDIRECTORY(dandroid_trb1)


# Work-in-progress / unofficial robots.
IF(NOT OPTION_OFFICIAL_ONLY)
	SD_ADD_SUBDIRECTORY(dandroid_lp1)

	SD_ADD_SUBDIRECTORY(simplix_lp1)
	SD_ADD_SUBDIRECTORY(simplix_ref)
	
	SD_ADD_SUBDIRECTORY(usr_lp1)
	#SD_ADD_SUBDIRECTORY(usr_mpa1)
	SD_ADD_SUBDIRECTORY(usr_mpa11)
	SD_ADD_SUBDIRECTORY(usr_mpa12)
	SD_ADD_SUBDIRECTORY(usr_mp10)
	SD_ADD_SUBDIRECTORY(usr_srw)
	
	SD_ADD_SUBDIRECTORY(shadow_67GP)
	SD_ADD_SUBDIRECTORY(shadow_mpa1)
	SD_ADD_SUBDIRECTORY(shadow_mpa11)
	SD_ADD_SUBDIRECTORY(shadow_mpa12)	
	SD_ADD_SUBDIRECTORY(shadow_sc)
	SD_ADD_SUBDIRECTORY(shadow_srw)

	#SD_ADD_SUBDIRECTORY(bt)
	#SD_ADD_SUBDIRECTORY(hymie)
	#SD_ADD_SUBDIRECTORY(K1999)
	#SD_ADD_SUBDIRECTORY(kilo2008)

	SD_ADD_SUBDIRECTORY(urbanski)
ENDIF()

=== packaging/3rdParty-devel/CMakeLists.txt ===
#
#==============================================================================
#
#    file                 : CMakeLists.txt
#    created              : Aug 5 2015
#    copyright            : (C) 2015 Joe Thompson
#    email                : beaglejoe@users.sourceforge.net
#    version              : $Id: $
#
#==============================================================================
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#==============================================================================
#
# (hashtag) starts a comment
cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)

project(3rdParty-2.3)

include(ExternalProject)
include(CMakeDependentOption)


# Setup some defualts...

# Setup the configuration
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
    message("No CMAKE_BUILD_TYPE specified, defaulting to ${CMAKE_BUILD_TYPE}") 
endif(NOT CMAKE_BUILD_TYPE)

# Setup the install prefix.
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "./installed" CACHE PATH "Prefix prepended to install directories" FORCE)
endif(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)


if(MINGW)
   link_directories(/usr/lib /usr/local/lib)
   include_directories(AFTER /usr/include /usr/local/include)
endif(MINGW)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/")
message(STATUS "CMAKE_SOURCE_DIR = ${CMAKE_SOURCE_DIR}")

set(EXTERNALS_PREFIX "${CMAKE_CURRENT_BINARY_DIR}/externals" CACHE PATH "")
set(EXTERNALS_INSTALL_DIR "${CMAKE_CURRENT_BINARY_DIR}/3rdParty" CACHE PATH "")
set(EXTERNALS_CMAKE_ARGS -DCMAKE_INSTALL_PREFIX=${EXTERNALS_INSTALL_DIR} CACHE PATH "")

set_property(DIRECTORY PROPERTY EP_BASE ${EXTERNALS_PREFIX})

if(WIN32)
   set(OPTION_OPENGL_HEADERS true CACHE BOOL "Download the OpenGL headers")
endif(WIN32)


option(OPTION_SDL_1x "Download and Build SDL 1.x" true)
option(OPTION_SDL_2x "Download and Build SDL 2.x" true)
option(OPTION_OPENAL "Download and Build OpenAL" true)
option(OPTION_PLIB "Download and Build PLIB" true)
cmake_dependent_option(OPTION_PLIB_USE_HEAD "Download and Build PLIB from the latest revision" true "OPTION_PLIB" false)
option(OPTION_JPEG "Download and Build libjpeg" true)
option(OPTION_FREESOLID "Download and Build FreeSOLID" true)
option(OPTION_ENET "Download and Build Enet" true)
option(OPTION_OGG "Download and Build libogg" true)
option(OPTION_VORBIS "Download and Build libvorbis" true)
option(OPTION_EXPAT "Download and Build Expat" true)
option(OPTION_ZLIB "Download and Build zlib" true)
option(OPTION_PNG "Download and Build libpng" true)
option(OPTION_SQLITE3 "Download and Build sqlite3" false)
option(OPTION_FREETYPE "Download and Build FreeType" true)
option(OPTION_CURL "Download and Build curl" true)
option(OPTION_OSG "Download and Build OpenSceneGraph" true)


# CMAKE_BUILD_TYPE does NOT work for Visual Studio or Xcode
# need to switch on configuration somehow
# or limit the choices
if(CMAKE_BUILD_TYPE MATCHES "Debug")
   set(SUPER_BUILD_POSTFIX "d")
else()
   set(SUPER_BUILD_POSTFIX "")
endif()

# OpenGL extensions (Windows only??)
message(STATUS "OpenGL extensions (Windows only??)")
if(WIN32 AND OPTION_OPENGL_HEADERS)
ExternalProject_Add(OpenGL-headers
   URL ${CMAKE_CURRENT_SOURCE_DIR}/patches/openglheaders.zip
   URL_HASH SHA256=4ba471b7306d47776c916bd507b89415baf6d5662e17a27c2c575d8e331c985b
   CMAKE_ARGS ${EXTERNALS_CMAKE_ARGS})
endif(WIN32 AND OPTION_OPENGL_HEADERS)

if(OPTION_SDL_1x)
ExternalProject_Add(SDL-1.2.15 
   URL https://www.libsdl.org/release/SDL-1.2.15.tar.gz 
   URL_HASH SHA256=d6d316a793e5e348155f0dd93b979798933fb98aa1edebcc108829d6474aad00 
   CMAKE_ARGS ${EXTERNALS_CMAKE_ARGS}
   DEPENDS OpenGL-headers
   )
ExternalProject_Add_Step(SDL-1.2.15 sdl1x_add_cmake
   COMMAND ${CMAKE_COMMAND} -E copy_if_different
           "${CMAKE_SOURCE_DIR}/patches/sdl-1.2.15.CMakeLists.txt"
           "<SOURCE_DIR>/CMakeLists.txt"
   DEPENDEES update # do after update
   DEPENDERS patch  # do before patch
)
endif(OPTION_SDL_1x)

# TODO - need to disable SDL2 static (it is overwritten by dll's SDL2.lib)
# message(WARNING "TODO - need to disable SDL2 static (it is overwritten by dll's SDL2.lib)")

if(OPTION_SDL_2x)
   set(SDL2_PROJECT SDL2-2.0.8)
   set(SDL2_ARGS ${EXTERNALS_CMAKE_ARGS} -DSDL_STATIC=Off)
#   set(SDL2_ARGS ${EXTERNALS_CMAKE_ARGS} -DSDL_STATIC=Off -DSDL_MAIN_HANDLED=True)
   #message(STATUS "CMAKE_SOURCE_DIR = ${CMAKE_SOURCE_DIR}")
   ExternalProject_Add(${SDL2_PROJECT} 
   URL https://www.libsdl.org/release/SDL2-2.0.8.tar.gz 
   URL_HASH SHA256=edc77c57308661d576e843344d8638e025a7818bff73f8fbfab09c3c5fd092ec

   CMAKE_ARGS ${SDL2_ARGS}
   DEPENDS OpenGL-headers
   )

else(OPTION_SDL_2x)
   set(SDL2_PROJECT )
endif(OPTION_SDL_2x)

if(OPTION_OPENAL)
ExternalProject_Add(openal-soft-1.19.0 
   URL http://kcat.strangesoft.net/openal-releases/openal-soft-1.19.0.tar.bz2 
   URL_HASH SHA256=f1adf3a6e73e2f9270a0fd00887ea23793968fa787f60dcdec41a3b2f42a0ed6
   CMAKE_ARGS ${EXTERNALS_CMAKE_ARGS})
endif(OPTION_OPENAL)

if(OPTION_PLIB)
   if(OPTION_PLIB_USE_HEAD)
   ExternalProject_Add(plib-1.8.5-head 
      SVN_REPOSITORY  svn://svn.code.sf.net/p/plib/code/trunk
      CMAKE_ARGS ${EXTERNALS_CMAKE_ARGS}
      DEPENDS OpenGL-headers
      )
      ExternalProject_Add_Step(plib-1.8.5-head plib_add_cmake
      COMMAND ${CMAKE_COMMAND} -E copy_if_different
              "${CMAKE_SOURCE_DIR}/patches/plib-1.8.5.CMakeLists.txt"
              "<SOURCE_DIR>/CMakeLists.txt"
      DEPENDEES update # do after update
      DEPENDERS patch  # do before patch
      )

   else(OPTION_PLIB_USE_HEAD)

   ExternalProject_Add(plib-1.8.5 
      URL https://plib.sourceforge.net/dist/plib-1.8.5.tar.gz 
      URL_HASH SHA256=485b22bf6fdc0da067e34ead5e26f002b76326f6371e2ae006415dea6a380a32 
      CMAKE_ARGS ${EXTERNALS_CMAKE_ARGS}
      DEPENDS OpenGL-headers
      )
      ExternalProject_Add_Step(plib-1.8.5 plib_add_cmake
      COMMAND ${CMAKE_COMMAND} -E copy_if_different
              "${CMAKE_SOURCE_DIR}/patches/plib-1.8.5.CMakeLists.txt"
              "<SOURCE_DIR>/CMakeLists.txt"
      DEPENDEES update # do after update
      DEPENDERS patch  # do before patch
      )
   endif(OPTION_PLIB_USE_HEAD)
endif(OPTION_PLIB)

if(OPTION_JPEG)
   set(JPG_PROJECT jpeg-9c)
   ExternalProject_Add(${JPG_PROJECT}
   URL http://ijg.org/files/jpegsrc.v9c.tar.gz
   URL_HASH SHA256=650250979303a649e21f87b5ccd02672af1ea6954b911342ea491f351ceb7122
   CMAKE_ARGS ${EXTERNALS_CMAKE_ARGS}
   )
   ExternalProject_Add_Step(${JPG_PROJECT} jpeg_add_cmake
   COMMAND ${CMAKE_COMMAND} -E copy_if_different
           "${CMAKE_SOURCE_DIR}/patches/jpeg-9c.CMakeLists.txt"
           "<SOURCE_DIR>/CMakeLists.txt"
   DEPENDEES update # do after update
   DEPENDERS patch  # do before patch
   )
   ExternalProject_Add_Step(${JPG_PROJECT} jpeg_config
   COMMAND ${CMAKE_COMMAND} -E copy_if_different
           "<SOURCE_DIR>/jconfig.vc"
           "<SOURCE_DIR>/jconfig.h"
   DEPENDEES update # do after update
   DEPENDERS patch  # do before patch
   )
else(OPTION_JPEG)
   set(JPG_PROJECT )
endif(OPTION_JPEG)

if(OPTION_FREESOLID)
#message(WARNING "TODO - need to decide between the patches for FreeSOLID-2.1.1 OR FreeSOLID-2.1.2")
#ExternalProject_Add(FreeSOLID-2.1.1 
#   DOWNLOAD_NAME FreeSOLID-2.1.1.zip
#   URL https://sourceforge.net/projects/freesolid/files/FreeSOLID/FreeSOLID-2.1.1.zip/FreeSOLID-2.1.1.zip/download 
#   URL_HASH SHA256=5a4f8576e27223f03ad0add76a79b06db6cd8f15c8d2767ea35e0c540ba1bee8 
#   CMAKE_ARGS ${EXTERNALS_CMAKE_ARGS}
#   UPDATE_COMMAND ""
#   PATCH_COMMAND ""
#   CONFIGURE_COMMAND ""
#   BUILD_COMMAND ""
#   INSTALL_COMMAND ""  
#   )

set(FreeSOLID_ARGS ${EXTERNALS_CMAKE_ARGS} -D'CMAKE_DEBUG_POSTFIX=""')
ExternalProject_Add(FreeSOLID-2.1.2
   DOWNLOAD_NAME FreeSOLID-2.1.2.zip
   URL https://sourceforge.net/projects/freesolid/files/FreeSOLID-2.1.2.zip/download 
   URL_HASH SHA256=89edc6afdd9d60c8020b2b865b61558c86a8928dc6f1773b9f4708b5c28eb873 
   CMAKE_ARGS ${FreeSOLID_ARGS}
   )
ExternalProject_Add_Step(FreeSOLID-2.1.2 freesolid_add_cmake
   COMMAND ${CMAKE_COMMAND} -E copy_if_different
           "${CMAKE_SOURCE_DIR}/patches/FreeSOLID-2.1.2.CMakeLists.txt"
           "<SOURCE_DIR>/CMakeLists.txt"
   DEPENDEES update # do after update
   DEPENDERS patch  # do before patch
   )
endif(OPTION_FREESOLID)

if(OPTION_ENET)
ExternalProject_Add(enet-1.3.13
   URL http://enet.bespin.org/download/enet-1.3.13.tar.gz
   URL_HASH SHA256=e36072021faa28731b08c15b1c3b5b91b911baf5f6abcc7fe4a6d425abada35c
   CMAKE_ARGS ${EXTERNALS_CMAKE_ARGS}
   )
   ExternalProject_Add_Step(enet-1.3.13 enet_add_cmake
   COMMAND ${CMAKE_COMMAND} -E copy_if_different
           "${CMAKE_SOURCE_DIR}/patches/enet-1.3.13.CMakeLists.txt"
           "<SOURCE_DIR>/CMakeLists.txt"
   DEPENDEES update # do after update
   DEPENDERS patch  # do before patch
   )
endif(OPTION_ENET)

if(OPTION_OGG)
ExternalProject_Add(libogg-1.3.3
   URL http://downloads.xiph.org/releases/ogg/libogg-1.3.3.tar.gz
   URL_HASH SHA256=c2e8a485110b97550f453226ec644ebac6cb29d1caef2902c007edab4308d985
   CMAKE_ARGS ${EXTERNALS_CMAKE_ARGS}
   )
   ExternalProject_Add_Step(libogg-1.3.3 libogg_add_cmake
   COMMAND ${CMAKE_COMMAND} -E copy_if_different
           "${CMAKE_SOURCE_DIR}/patches/libogg-1.3.3.CMakeLists.txt"
           "<SOURCE_DIR>/CMakeLists.txt"
   DEPENDEES update # do after update
   DEPENDERS patch  # do before patch
   )
endif(OPTION_OGG)

if(OPTION_VORBIS)
ExternalProject_Add(libvorbis-1.3.6
   URL http://downloads.xiph.org/releases/vorbis/libvorbis-1.3.6.tar.gz
   URL_HASH SHA256=6ed40e0241089a42c48604dc00e362beee00036af2d8b3f46338031c9e0351cb
   CMAKE_ARGS ${EXTERNALS_CMAKE_ARGS}
   DEPENDS "libogg-1.3.3"
   )
   ExternalProject_Add_Step(libvorbis-1.3.6 libvorbis_add_cmake
   COMMAND ${CMAKE_COMMAND} -E copy_if_different
           "${CMAKE_SOURCE_DIR}/patches/libvorbis-1.3.6.CMakeLists.txt"
           "<SOURCE_DIR>/CMakeLists.txt"
   DEPENDEES update # do after update
   DEPENDERS patch  # do before patch
   )
endif(OPTION_VORBIS)

#disable building unneeded sub projects (they failed with VS2008)
set(EXPAT_ARGS ${EXTERNALS_CMAKE_ARGS} -DBUILD_tests=off -DBUILD_examples=off -DBUILD_tools=off -DCMAKE_DEBUG_POSTFIX='')
if(OPTION_EXPAT)
   ExternalProject_Add(expat-2.2.0
   DOWNLOAD_NAME expat-2.2.0.tar.bz2
   URL https://sourceforge.net/projects/expat/files/expat/2.2.0/expat-2.2.0.tar.bz2/download
   URL_HASH SHA256=d9e50ff2d19b3538bd2127902a89987474e1a4db8e43a66a4d1a712ab9a504ff
   CMAKE_ARGS ${EXPAT_ARGS}
   #UPDATE_COMMAND ""
   #PATCH_COMMAND ""
   #CONFIGURE_COMMAND ""
   #BUILD_COMMAND ""
   #INSTALL_COMMAND ""  
   )
   # Hopefully temporary - report to Expat
   # https://sourceforge.net/p/expat/bugs/534/
   message(STATUS "Todo - remove after Expat's bug 534 gets fixed...")
   ExternalProject_Add_Step(expat-2.2.0 expat-2.2.0_fix_cmake
   COMMAND ${CMAKE_COMMAND} -E copy_if_different
           "${CMAKE_SOURCE_DIR}/patches/expat-2.2.0-CMakeLists.txt"
           "<SOURCE_DIR>/CMakeLists.txt"
   DEPENDEES update # do after update
   DEPENDERS patch  # do before patch
   )
endif(OPTION_EXPAT)

message(STATUS "CMAKE_COMMAND = ${CMAKE_COMMAND}")

=== src/drivers/CMakeLists.txt ===
INCLUDE(../../cmake/macros.cmake)

# Official robots.
SD_ADD_SUBDIRECTORY(human)
SD_ADD_SUBDIRECTORY(dandroid)
SD_ADD_SUBDIRECTORY(kilo2008)
SD_ADD_SUBDIRECTORY(networkhuman)
SD_ADD_SUBDIRECTORY(simplix)
SD_ADD_SUBDIRECTORY(usr)

# Work-in-progress / unofficial robots.
IF(NOT OPTION_OFFICIAL_ONLY)

  # Work-in-progress.
  SD_ADD_SUBDIRECTORY(shadow)

  IF(OPTION_3RDPARTY_SQLITE3)
  	SD_ADD_SUBDIRECTORY(replay)
  ENDIF()

  # Obsolete (as robot samples).
  #SD_ADD_SUBDIRECTORY(bt)
  #SD_ADD_SUBDIRECTORY(hymie)
  #SD_ADD_SUBDIRECTORY(K1999)

  SD_ADD_SUBDIRECTORY(urbanski)
ENDIF()

=== src/interfaces/CMakeLists.txt ===
INCLUDE(../../cmake/macros.cmake)

SET(INTERFACES_HEADERS car.h graphic.h playerpref.h raceman.h
                       replay.h robot.h telemetry.h track.h
                       iraceengine.h iuserinterface.h igraphicsengine.h
                       iphysicsengine.h itrackloader.h isoundengine.h
                       camera.h)

# Fictive = no-output target, for having source files available in IDEs.
ADD_CUSTOM_TARGET(interfaces SOURCES ${INTERFACES_HEADERS})

SD_INSTALL_FILES(INCLUDE FILES ${INTERFACES_HEADERS})

=== src/libs/CMakeLists.txt ===
INCLUDE("../../cmake/macros.cmake")

IF(NOT OPTION_3RDPARTY_EXPAT)
	ADD_SUBDIRECTORY(txml)
ENDIF(NOT OPTION_3RDPARTY_EXPAT)

ADD_SUBDIRECTORY(tgf)
ADD_SUBDIRECTORY(tgfclient)
ADD_SUBDIRECTORY(tgfdata)
ADD_SUBDIRECTORY(robottools)
ADD_SUBDIRECTORY(learning)
ADD_SUBDIRECTORY(math)
ADD_SUBDIRECTORY(portability)

# Work-in-progress 
IF(NOT OPTION_OFFICIAL_ONLY)
	SD_ADD_SUBDIRECTORY(ephemeris)
	#SD_ADD_SUBDIRECTORY(metar)
ENDIF()

=== src/main/CMakeLists.txt ===
INCLUDE(../../cmake/macros.cmake)

PROJECT(speed-dreams-2)

SET(_TARGET_NAME speed-dreams-2)

SET(_SOURCES main.cpp)
IF(MSVC)
	SET(_SOURCES ${_SOURCES} main.rc resource.h ../../data/data/icons/icon.ico)
ENDIF(MSVC)

ADD_INTERFACE_INCLUDEDIR()
ADD_SDLIB_INCLUDEDIR(tgf tgfclient tgfdata math portability)

IF(OPTION_SDL2)
	ADD_SDL2_INCLUDEDIR()
ELSE(OPTION_SDL2)
	ADD_SDL_INCLUDEDIR()
ENDIF(OPTION_SDL2)

ADD_PLIB_INCLUDEDIR()

# Disable developer warning
IF(COMMAND CMAKE_POLICY)
	CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

IF(MSVC)
    # Ignore some run-time libs to avoid link time warnings and sometimes even crashes.
    SET(CMAKE_EXE_LINKER_FLAGS_DEBUG 
        "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:libcmt.lib")
    SET(CMAKE_EXE_LINKER_FLAGS_RELEASE 
        "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /NODEFAULTLIB:libcmt.lib")
ENDIF(MSVC)

SD_ADD_EXECUTABLE(${_TARGET_NAME} ${_SOURCES})

ADD_SDLIB_LIBRARY(${_TARGET_NAME} portability tgf tgfclient tgfdata)

# Needed when using the "MinGW Makefiles" CMake generator (but not with the "MSYS Makefiles" one !)
IF(MINGW)
	TARGET_LINK_LIBRARIES(${_TARGET_NAME} ${MINGW32_LIBRARY})
ENDIF(MINGW)

IF(UNIX)
	SD_INSTALL_FILES(MAN man6 PREFIX ${SOURCE_DIR}/doc/man FILES ${_TARGET_NAME}.6)
ENDIF(UNIX)

SD_INSTALL_FILES(BIN TARGETS ${_TARGET_NAME})

IF((APPLE) AND ("${CMAKE_INSTALL_PREFIX}" MATCHES "\\.app$"))
   SET(OSG_PLUGIN_DIR /opt/local/lib/osgPlugins-3.4.0)
   message("OSG_PLUGIN_DIR = ${OSG_PLUGIN_DIR}")
   INSTALL(FILES ../../packaging/OSX/Info.plist DESTINATION ./Contents)
INSTALL(FILES ../../packaging/OSX/sd-icon-mac-256.icns DESTINATION ./Contents/Resources)
   SET(APPS "\${CMAKE_INSTALL_PREFIX}/games/${_TARGET_NAME}")
   SET(DIRS)
#SET(DIRS ${DIRS} "${OSG_PLUGIN_DIR}")
   SET(DIRS ${DIRS} "\${CMAKE_INSTALL_PREFIX}/MacOS")
   SET(DIRS ${DIRS} "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/lib")
   SET(DIRS ${DIRS} /opt/local/lib)

   # These should be pulled into "\${CMAKE_INSTALL_PREFIX}/MacOS" as needed by others
#LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/lib/libephemeris.dylib")
#LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/lib/liblearning.dylib")
#LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/lib/libnetworking.dylib")
#LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/lib/libportability.dylib")
#LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/lib/librobottools.dylib")
#LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/lib/libtgf.dylib")
#LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/lib/libtgfclient.dylib")
#LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/lib/libtgfdata.dylib")

   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/modules/graphic/ssggraph.so")

   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/modules/racing/standardgame.so")
IF(NOT OPTION_OFFICIAL_ONLY)
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/modules/racing/genparoptv1.so")
ENDIF(NOT OPTION_OFFICIAL_ONLY)
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/modules/simu/simuv4.so")
IF(NOT OPTION_OFFICIAL_ONLY)
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/modules/simu/simuv3.so")
ENDIF(NOT OPTION_OFFICIAL_ONLY)
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/modules/simu/simuv2.1.so")

   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/modules/sound/snddefault.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/modules/telemetry/telemetryv1.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/modules/track/trackv1.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/modules/userinterface/legacymenu.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/modules/userinterface/textonly.so")

   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/dandroid/dandroid.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/dandroid_36GP/dandroid_36GP.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/dandroid_67GP/dandroid_67GP.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/dandroid_lp1/dandroid_lp1.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/dandroid_ls1/dandroid_ls1.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/dandroid_ls2/dandroid_ls2.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/dandroid_mpa1/dandroid_mpa1.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/dandroid_mpa11/dandroid_mpa11.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/dandroid_mpa12/dandroid_mpa12.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/dandroid_rs/dandroid_rs.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/dandroid_sc/dandroid_sc.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/dandroid_srw/dandroid_srw.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/dandroid_trb1/dandroid_trb1.so")

   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/human/human.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/kilo2008/kilo2008.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/networkhuman/networkhuman.so")
#   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/replay/replay.so")
IF(NOT OPTION_OFFICIAL_ONLY)
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/shadow/shadow.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/shadow_36GP/shadow_36GP.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/shadow_67GP/shadow_67GP.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/shadow_lp1/shadow_lp1.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/shadow_ls1/shadow_ls1.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/shadow_ls2/shadow_ls2.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/shadow_mp5/shadow_mp5.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/shadow_mpa1/shadow_mpa1.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/shadow_mpa11/shadow_mpa11.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/shadow_mpa12/shadow_mpa12.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/shadow_ref/shadow_ref.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/shadow_sc/shadow_sc.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/shadow_srw/shadow_srw.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/shadow_trb1/shadow_trb1.so")
ENDIF(NOT OPTION_OFFICIAL_ONLY)
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/simplix/simplix.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/simplix_36GP/simplix_36GP.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/simplix_lp1/simplix_lp1.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/simplix_ls1/simplix_ls1.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/simplix_ls2/simplix_ls2.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/simplix_mp5/simplix_mp5.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/simplix_mpa1/simplix_mpa1.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/simplix_mpa11/simplix_mpa11.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/simplix_mpa12/simplix_mpa12.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/simplix_ref/simplix_ref.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/simplix_sc/simplix_sc.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/simplix_srw/simplix_srw.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/simplix_trb1/simplix_trb1.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/usr/usr.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/usr_36GP/usr_36GP.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/usr_lp1/usr_lp1.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/usr_ls1/usr_ls1.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/usr_ls2/usr_ls2.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/usr_mpa1/usr_mpa1.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/usr_mpa11/usr_mpa11.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/usr_mpa12/usr_mpa12.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/usr_rs/usr_rs.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/usr_sc/usr_sc.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/usr_trb1/usr_trb1.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/usr_mp10/usr_mp10.so")
   LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/drivers/usr_srw/usr_srw.so")

   IF(OPTION_OSGGRAPH)
#SET(OSG_PLUGIN_DIR /opt/local/lib/osgPlugins-3.4.0)
#INSTALL(DIRECTORY "${OSG_PLUGIN_DIR}" DESTINATION ./MacOS FILES_MATCHING PATTERN "*.so")
      LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/lib64/games/${_TARGET_NAME}/modules/graphic/osggraph.so")
      FILE(GLOB osg_plugins "${OSG_PLUGIN_DIR}/*.so")
message("osg_plugins = ${osg_plugins}")
      FOREACH(pi ${osg_plugins})
INSTALL(FILES ${pi} DESTINATION ./games/PlugIns/osgPlugins-3.4.0)
         GET_FILENAME_COMPONENT(fname ${pi} NAME)
        message("fname = ${fname}")
         LIST(APPEND PlugIns "\${CMAKE_INSTALL_PREFIX}/games/PlugIns/osgPlugins-3.4.0/${fname}")
      ENDFOREACH()
   ENDIF(OPTION_OSGGRAPH)

   message("PlugIns = ${PlugIns}")
message("DIRS = ${DIRS}")


# These are installed by their respective CMakeLists.txt
# Executables
#LIST(APPEND PlugIns ${CMAKE_INSTALL_PREFIX}/games/sd2-accc)
#LIST(APPEND PlugIns ${CMAKE_INSTALL_PREFIX}/games/sd2-menuview)
#LIST(APPEND PlugIns ${CMAKE_INSTALL_PREFIX}/games/sd2-nfs2ac)
#LIST(APPEND PlugIns ${CMAKE_INSTALL_PREFIX}/games/sd2-nfsperf)
#LIST(APPEND PlugIns ${CMAKE_INSTALL_PREFIX}/games/sd2-sd2-trackgen)

   INSTALL(CODE "
   INCLUDE(BundleUtilities)
   SET(BU_CHMOD_BUNDLE_ITEMS ON)
   FIXUP_BUNDLE(\"${APPS}\" \"${PlugIns}\" \"${DIRS}\")")

ENDIF()

# Under Windows, install needed 3rd party DLLs close to Speed Dreams executable.
IF(WIN32)

=== src/tools/CMakeLists.txt ===
INCLUDE(../../cmake/macros.cmake)

SD_ADD_SUBDIRECTORY(accc)
SD_ADD_SUBDIRECTORY(nfs2ac)
SD_ADD_SUBDIRECTORY(nfsperf)
SD_ADD_SUBDIRECTORY(trackgen)
ADD_SUBDIRECTORY(xmlversion)

IF(NOT OPTION_OFFICIAL_ONLY)
	SD_ADD_SUBDIRECTORY(menuview)
ENDIF(NOT OPTION_OFFICIAL_ONLY)

=== data/cars/categories/CMakeLists.txt ===
INCLUDE(../../../cmake/macros.cmake)

# Official car sets.
SD_INSTALL_FILES(DATA cars/categories
                 FILES Supercars.xml 36GP.xml 67GP.xml TRB1.xml LS-GT1.xml LS-GT2.xml MP5.xml MPA1.xml MPA11.xml 
                 MPA12.xml RS.xml Preview.xml SupercarsWithRearWing.xml)

# Internal / non-official / work-in-progress car sets
# (we deliver all of them in case some advanced users / developers
#  manually install cars from these categories).
SD_INSTALL_FILES(DATA cars/categories
                 FILES References.xml LS-P1.xml LS-P2.xml MP1.xml MP10.xml Raid-T1.xml Nascar.xml Fun-Racer.xml)

=== data/cars/models/CMakeLists.txt ===
INCLUDE(../../../cmake/macros.cmake)

# Official car sets.
SD_ADD_SUBDIRECTORY(36gp-century-r11b)
SD_ADD_SUBDIRECTORY(36gp-ettore-t59)
SD_ADD_SUBDIRECTORY(36gp-milano-12c36)
SD_ADD_SUBDIRECTORY(36gp-milano-tipop3)
SD_ADD_SUBDIRECTORY(36gp-motorunion-typec)
SD_ADD_SUBDIRECTORY(36gp-silber-w25b)
SD_ADD_SUBDIRECTORY(36gp-tridenti-6c34)
SD_ADD_SUBDIRECTORY(36gp-tridenti-v8ri)

SD_ADD_SUBDIRECTORY(67gp-upping-ut19)
SD_ADD_SUBDIRECTORY(67gp-guthrie-eagle)

SD_ADD_SUBDIRECTORY(trb1-boxer-trbrs)
SD_ADD_SUBDIRECTORY(trb1-cavallo-360rb)
SD_ADD_SUBDIRECTORY(trb1-sector-rb1)
SD_ADD_SUBDIRECTORY(trb1-silber-rblk)
SD_ADD_SUBDIRECTORY(trb1-spirit-rb1lt)
SD_ADD_SUBDIRECTORY(trb1-taipan-rb1)
SD_ADD_SUBDIRECTORY(trb1-vieringe-5rb/)
SD_ADD_SUBDIRECTORY(trb1-zaxxon-rb)

SD_ADD_SUBDIRECTORY(sc-boxer-96)
SD_ADD_SUBDIRECTORY(sc-cavallo-360)
SD_ADD_SUBDIRECTORY(sc-fmc-gt4)
SD_ADD_SUBDIRECTORY(sc-lynx-220)
SD_ADD_SUBDIRECTORY(sc-kanagawa-z35gts)
SD_ADD_SUBDIRECTORY(sc-kongei-kk8s)
SD_ADD_SUBDIRECTORY(sc-murasama-nsx)
SD_ADD_SUBDIRECTORY(sc-spirit-300)

SD_ADD_SUBDIRECTORY(srw-sector-p4)
SD_ADD_SUBDIRECTORY(srw-kongei-kk8s)
SD_ADD_SUBDIRECTORY(srw-boxer-ts)
SD_ADD_SUBDIRECTORY(srw-kanagawa-gtr)

SD_ADD_SUBDIRECTORY(ls1-archer-r9)
SD_ADD_SUBDIRECTORY(ls1-cavallo-570s1)
SD_ADD_SUBDIRECTORY(ls1-newcastle-fury)
SD_ADD_SUBDIRECTORY(ls1-taipan-ltsr)
SD_ADD_SUBDIRECTORY(ls1-toro-rgt)
SD_ADD_SUBDIRECTORY(ls1-vulture-v6r)
SD_ADD_SUBDIRECTORY(ls1-zentek-z7r)

SD_ADD_SUBDIRECTORY(ls2-bavaria-g3gtr)
SD_ADD_SUBDIRECTORY(ls2-boxer-96rsr)
SD_ADD_SUBDIRECTORY(ls2-cavallo-360r)
SD_ADD_SUBDIRECTORY(ls2-condor-c400r)
SD_ADD_SUBDIRECTORY(ls2-morley-r900)
SD_ADD_SUBDIRECTORY(ls2-sprite-gts)
SD_ADD_SUBDIRECTORY(ls2-vortex-gt)
SD_ADD_SUBDIRECTORY(ls2-lynx-xkr)

SD_ADD_SUBDIRECTORY(mpa1-murasama)
SD_ADD_SUBDIRECTORY(mpa1-hartbill-2002)
SD_ADD_SUBDIRECTORY(mpa1-ffr)
SD_ADD_SUBDIRECTORY(mpa1-furia)
SD_ADD_SUBDIRECTORY(mpa1-team-lynx)

SD_ADD_SUBDIRECTORY(mpa11-murasama)
SD_ADD_SUBDIRECTORY(mpa12-murasama)

SD_ADD_SUBDIRECTORY(mp5-fmc)
SD_ADD_SUBDIRECTORY(mp5-fmc-drift)
SD_ADD_SUBDIRECTORY(mp5-fmc-speedy)

SD_ADD_SUBDIRECTORY(rs1-citrus-cs4)
SD_ADD_SUBDIRECTORY(rs1-fmc-centre)
SD_ADD_SUBDIRECTORY(rs1-kenji-08)
SD_ADD_SUBDIRECTORY(rs2-fai-dot)
SD_ADD_SUBDIRECTORY(rs2-lion-2m)

# Work-in-progress car sets.
IF(NOT OPTION_OFFICIAL_ONLY)

	SD_ADD_SUBDIRECTORY(fun-racer)

	SD_ADD_SUBDIRECTORY(ref-boxer-gt3-rs-2010)
	SD_ADD_SUBDIRECTORY(ref-sector-p4)
	SD_ADD_SUBDIRECTORY(ref-sphere-osg)

	SD_ADD_SUBDIRECTORY(ls1-marisatech-gt4r)

	SD_ADD_SUBDIRECTORY(gtc-aichi-aidoru)

	SD_ADD_SUBDIRECTORY(mp1-diamond-d25)
	SD_ADD_SUBDIRECTORY(mp1-cavallo-tr06)
	SD_ADD_SUBDIRECTORY(mp1-vicente)
	
	SD_ADD_SUBDIRECTORY(lp1-lolita-exr57)
	SD_ADD_SUBDIRECTORY(lp1-luxura-lp02)
	SD_ADD_SUBDIRECTORY(lp1-pescy-p60)
	SD_ADD_SUBDIRECTORY(lp1-spire-s101)
	SD_ADD_SUBDIRECTORY(lp1-sprite-p1rs)
	SD_ADD_SUBDIRECTORY(lp1-vieringe-vr8)

	SD_ADD_SUBDIRECTORY(lp2-bravery-brc6)
	SD_ADD_SUBDIRECTORY(lp2-lolita-exr57)
	SD_ADD_SUBDIRECTORY(lp2-spire-s101)

	SD_ADD_SUBDIRECTORY(mp10-agl-kart)
	SD_ADD_SUBDIRECTORY(mp10-sdr-kart125)
	SD_ADD_SUBDIRECTORY(mp10-tuxkart)
	
	SD_ADD_SUBDIRECTORY(lancer09-wr)

	SD_ADD_SUBDIRECTORY(nascar-car1)
	SD_ADD_SUBDIRECTORY(nascar-car2)

ENDIF()

=== data/config/raceman/CMakeLists.txt ===
INCLUDE(../../../cmake/macros.cmake)

SET(_RACE_FILES practice.xml quickrace.xml
           singleevent-36gp.xml
           singleevent-challenge.xml singleevent-endurance.xml
           singleevent-ls-gt1.xml singleevent-mp5.xml
           championship.xml championship-supercars.xml championship-trb1.xml
           championship-36gp.xml championship-ls-gt1.xml championship-mp5.xml
           networkrace.xml championship-mpa1.xml championship-mpa11.xml career-36GP.xml career-supercars.xml
		   career_36GP.xmls career_MPA1.xmls
           career_supercars.xmls career_ls1.xmls)

SD_INSTALL_FILES(DATA config/raceman USER config/raceman FILES ${_RACE_FILES})

SET(_EXTRA_FILES extra/skill.xml)

SD_INSTALL_FILES(DATA config/raceman/extra USER config/raceman/extra 
                 FILES ${_EXTRA_FILES})

# Fictive = no-output target, for having source files available in IDEs.
ADD_CUSTOM_TARGET(raceman SOURCES ${_RACE_FILES} ${_EXTRA_FILES})

=== debian/changelog ===
speed-dreams (2.2.2-1~mx21+1) mx; urgency=medium

  * Initial packaging for MX-21.
  * Create initial desktop file for menu.
  * Move and rename icons.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Wed, 20 Oct 2021 14:22:16 -0400

speed-dreams (2.2.2-1~oibaf~h) hirsute; urgency=medium

  * Initial release. (Closes: #599884)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Fri, 10 May 2019 12:27:25 +0200

=== debian/control ===
Source: speed-dreams
Section: games
Priority: optional
Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Gürkan Myczko <gurkan@phys.ethz.ch>
Build-Depends:
 debhelper (>= 11),
 cmake,
 libcurl4-gnutls-dev,
 libenet-dev,
 libexpat1-dev,
 libjpeg-dev,
 libogg-dev,
 libopenal-dev,
 libopenscenegraph-dev (>= 3.4),
 libplib-dev,
 libpng-dev,
 libsdl2-dev,
 libvorbis-dev,
 libxmu-dev
Standards-Version: 4.3.0
Homepage: https://www.speed-dreams.org/

Package: speed-dreams
Architecture: amd64
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 speed-dreams-data,
 symlinks,
 ttf-bitstream-vera
Description: Open source motorsport simulation
 This is a 3d cross-platform, open source motorsport simulation and racing
 game. It is a fork of the open racing car simulator Torcs, aiming to implement
 exciting new features, cars, tracks and AI opponents to make a more enjoyable
 game for the player, as well as constantly improving visual and physics
 realism.

Package: speed-dreams-data
Architecture: all
Depends:
 ${misc:Depends}
Description: Open source motorsport simulation, data files
 This is a 3d cross-platform, open source motorsport simulation and racing
 game. It is a fork of the open racing car simulator Torcs, aiming to implement
 exciting new features, cars, tracks and AI opponents to make a more enjoyable
 game for the player, as well as constantly improving visual and physics
 realism.
 .
 This package contains the data files needed to play Speed Dreams.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_auto_build:
	# create symlink
	#ln -s /usr/share/fonts/truetype/dseg/DSEG7Modern-Regular.ttf platform/qt/Fonts/
	#symlinks -c platform/qt/Fonts/
	@echo auto build

override_dh_auto_clean:
	# delete symlink
	#rm -rf platform/qt/Fonts/DSEG7Modern-Regular.ttf
	rm -rf obj-*
	@echo auto clean
